﻿Imports System
Imports System.Text
Imports Microsoft.VisualBasic
Imports System.IO
Imports System.Threading

Public Class Files
    Public mySaveString As String = Nothing
    Public myCSVString As String = Nothing
    Public File1 As String = Nothing
    Public File2 As String = Nothing
    Public Warner As Boolean
    Public myHex As Boolean
    Public VHex As Boolean
    Public Stopper As Boolean
    Public loopCheck As Integer
    Public m_ProgressBar As frmMain
    Public stopWatch As New Stopwatch
    Public print As Boolean = True

    Public Sub New(ByRef p_form As frmMain)
        m_ProgressBar = p_form
    End Sub

    Public Sub Compare()
        Dim checker As Boolean = True
        Dim sizeFile1 As Integer = 0
        Dim sizeFile2 As Integer = 0
        loopCheck = 0
        Dim FileBytes2() As Byte = Nothing
        Dim FileBytes1() As Byte = Nothing
        Dim offsetInfo As String = Nothing

        Try
            If (File1 IsNot Nothing) Then
                ' Insert code to read the stream here.
                sizeFile1 = FileLen(File1)
                ReDim FileBytes1(sizeFile1)
                FileBytes1 = File.ReadAllBytes(File1)
            End If
        Catch Ex As Exception
            MessageBox.Show("Cannot read file from disk. Original error: " & Ex.Message)
            checker = False
        End Try

        Try
            If (File2 IsNot Nothing) Then
                ' Insert code to read the stream here.
                sizeFile2 = FileLen(File2)
                ReDim FileBytes2(sizeFile2)
                FileBytes2 = File.ReadAllBytes(File2)
            End If
        Catch Ex As Exception
            MessageBox.Show("Cannot read file from disk. Original error: " & Ex.Message)
            checker = False
        End Try

        If (Warner = True) Then
            If (sizeFile1 <> sizeFile2) Then
                If (MsgBox("The file sizes are not equal, do you want to continue?", MsgBoxStyle.YesNo, "Continue?") = MsgBoxResult.Yes) Then
                    checker = True
                Else
                    checker = False
                End If
            End If

            If (File1 = File2) Then
                If (MsgBox("It appears the two files are the same, do you want to continue?", MsgBoxStyle.YesNo, "Continue?") = MsgBoxResult.Yes) Then
                    checker = True
                Else
                    checker = False
                End If
            End If
        End If

        If (sizeFile1 > sizeFile2) Then
            loopCheck = sizeFile2
        Else
            loopCheck = sizeFile1
        End If

        If (checker = True) Then
            Dim myComp As Boolean = True
            mySaveString = "File 1 = " & File1 & vbNewLine & "File 2 = " & File2 & vbNewLine
            myCSVString = "File 1 = " & File1 & ",," & vbNewLine & "File 2 = " & File2 & ",," & vbNewLine & vbNewLine
            myCSVString = mySaveString & vbNewLine & "OFFSET,FILE 1,FILE 2" & vbNewLine


            Dim i As Integer
            m_ProgressBar.SetMax(loopCheck - 1)
            stopWatch.Reset()
            stopWatch.Start()
            For i = 0 To loopCheck - 1
                If Stopper = True Then
                    m_ProgressBar.Complete("Done")
                    Exit Sub
                End If

                If (FileBytes1(i) <> FileBytes2(i)) Then
                    If (myHex = True) Then
                        If (VHex = True) Then
                            offsetInfo = "OFFSET: " & Hex(i) & "    File 1: " & Hex(FileBytes1(i)) & "    File 2: " & Hex(FileBytes2(i))
                            myCSVString = myCSVString & Hex(i) & "," & Hex(FileBytes1(i)) & "," & Hex(FileBytes2(i)) & vbNewLine
                        Else
                            offsetInfo = "OFFSET: " & Hex(i) & "    File 1: " & FileBytes1(i) & "    File 2: " & FileBytes2(i)
                            myCSVString = myCSVString & Hex(i) & "," & FileBytes1(i) & "," & FileBytes2(i) & vbNewLine
                        End If
                    Else
                        If (VHex = True) Then
                            offsetInfo = "OFFSET: " & i & "    File 1: " & Hex(FileBytes1(i)) & "    File 2: " & Hex(FileBytes2(i))
                            myCSVString = myCSVString & i & "," & Hex(FileBytes1(i)) & "," & Hex(FileBytes2(i)) & vbNewLine
                        Else
                            offsetInfo = "OFFSET: " & i & "    File 1: " & FileBytes1(i) & "    File 2: " & FileBytes2(i)
                            myCSVString = myCSVString & i & "," & FileBytes1(i) & "," & FileBytes2(i) & vbNewLine
                        End If
                    End If

                    mySaveString = mySaveString & offsetInfo & vbNewLine
                    If print = True Then
                        m_ProgressBar.UpdateList(offsetInfo)
                    End If
                    myComp = False
                    m_ProgressBar.UpdateUI(i)
                End If
            Next i

            If myComp = True Then
                MsgBox("Compare is done, no differences.", MsgBoxStyle.OkOnly, "Done")
            End If
            m_ProgressBar.Complete("Done")
        End If
    End Sub
End Class
