﻿Imports System
Imports System.Text
Imports Microsoft.VisualBasic
Imports System.IO
Imports System.Threading

Public Class frmMain

    Dim myFiles As Files
    Dim Completed As Boolean = True
    Dim fileIndex As Integer = 2
    Dim fileSizes As Integer = 0
    Dim file1size As Integer = 0
    Dim file2size As Integer = 0
    Dim ThisTime As Decimal = 0.0
    Dim LastTime As Decimal = 0.0
    Dim DivAmount As Integer = 800
    Dim file1Path As String = CurDir()
    Dim file2Path As String = CurDir()
    Dim savePath As String = CurDir()

    Private Sub mnuAbout_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuAbout.Click
        MsgBox("Created by hatfarm aka Chris Voss" & Chr(10) & "email address: hatfarm@gmail.com", MsgBoxStyle.OkOnly, "About")
    End Sub

    Private Sub mnuExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuExit.Click
        If (Completed = True) Then
            Me.Hide()
            isRunning = False
        Else
            MsgBox("Please wait until the compare is complete to exit.", MsgBoxStyle.OkOnly, "Please wait")
        End If
    End Sub

    Private Sub frmMain_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        myFiles.Stopper = True
        If (Completed = True) Then
            Me.Hide()
            isRunning = False
        End If
    End Sub

    Private Sub frmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        btnCompare.Text = Chr(161) & "&Compare!"
        myFiles = New Files(Me)
        mnuNumerical.Checked = True
        mnuVNumerical.Checked = True
        myFiles.Stopper = True
        mnuSave.Enabled = False
        mnuShowInfo.Checked = True
    End Sub

    Private Sub btnChgFile1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnChgFile1.Click
        Dim myStream1 As String = Nothing
        Dim openFileDialog As New OpenFileDialog()
        openFileDialog.InitialDirectory = file1Path
        openFileDialog.Filter = "dat files (*.dat)|*.dat|All files (*.*)|*.*"
        openFileDialog.FilterIndex = 2
        openFileDialog.RestoreDirectory = True
        If openFileDialog.ShowDialog() = System.Windows.Forms.DialogResult.OK Then
            myStream1 = openFileDialog.ToString
            Dim cut As String = "System.Windows.Forms.OpenFileDialog: Title: , FileName: "
            myStream1 = myStream1.Remove(0, cut.Length)
            file1Path = StrReverse(myStream1)
            file1Path = StrReverse(file1Path.Remove(0, file1Path.IndexOf("\")))
            If (myStream1 IsNot Nothing) Then
                txtFile1.Text = myStream1
            End If
            file1size = FileLen(txtFile1.Text)
            lblFile1SizeNum.Text = file1size.ToString
        End If
    End Sub

    Private Sub btnFile2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFile2.Click
        Dim myStream2 As String = Nothing
        Dim openFileDialog As New OpenFileDialog()
        openFileDialog.InitialDirectory = file2Path
        openFileDialog.Filter = "dat files (*.dat)|*.dat|All files (*.*)|*.*"
        openFileDialog.FilterIndex = 2
        openFileDialog.RestoreDirectory = True
        If openFileDialog.ShowDialog() = System.Windows.Forms.DialogResult.OK Then
            myStream2 = openFileDialog.ToString
            Dim cut As String = "System.Windows.Forms.OpenFileDialog: Title: , FileName: "
            myStream2 = myStream2.Remove(0, cut.Length)
            file2Path = StrReverse(myStream2)
            file2Path = StrReverse(file2Path.Remove(0, file2Path.IndexOf("\")))
            If (myStream2 IsNot Nothing) Then
                txtFile2.Text = myStream2
            End If
            file2size = FileLen(txtFile2.Text)
            lblFile2SizeNum.Text = file2size.ToString
        End If
    End Sub

    Private Sub btnCompare_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCompare.Click
        mnuStop.Enabled = True
        myFiles.Warner = mnuWarning.Checked
        myFiles.myHex = mnuHex.Checked
        myFiles.VHex = mnuVHex.Checked
        Me.mnuOptions.Enabled = False
        myFiles.Stopper = False
        Completed = False
        lstDifference.Items.Clear()
        myFiles.File1 = txtFile1.Text
        myFiles.File2 = txtFile2.Text
        Dim t As Thread
        t = New Thread(New ThreadStart(AddressOf myFiles.Compare))
        t.Start()
        mnuSave.Enabled = True
    End Sub

    Private Sub mnuSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuSave.Click
        Dim myStream3 As String = Nothing
        ' Encode the entire string.
        Dim u16LE As Encoding = Encoding.Default
        Dim bData As Byte()
        Dim saveFileDialog As New SaveFileDialog()
        saveFileDialog.InitialDirectory = savePath
        saveFileDialog.Filter = "Comma Separated Values (*.csv)|*.csv|Text files (*.txt)|*.txt|All files (*.*)|*.*"

        saveFileDialog.FilterIndex = fileIndex
        saveFileDialog.RestoreDirectory = True
        If saveFileDialog.ShowDialog() = System.Windows.Forms.DialogResult.OK Then
            Try
                If (saveFileDialog.FilterIndex = 1) Then
                    ReDim bData(Len(myFiles.myCSVString))
                    bData = u16LE.GetBytes(myFiles.myCSVString)
                Else
                    ReDim bData(Len(myFiles.mySaveString))
                    bData = u16LE.GetBytes(myFiles.mySaveString)
                End If
                fileIndex = saveFileDialog.FilterIndex
                myStream3 = saveFileDialog.ToString
                Dim cut As String = "System.Windows.Forms.SaveFileDialog: Title: , FileName: "
                myStream3 = myStream3.Remove(0, cut.Length)
                savePath = StrReverse(myStream3)
                savePath = StrReverse(savePath.Remove(0, savePath.IndexOf("\")))
                If (myStream3 IsNot Nothing) Then
                    ' Insert code to read the stream here.
                    File.WriteAllBytes(myStream3, bData)
                End If
            Catch Ex As Exception
                MessageBox.Show("Cannot save file to disk. Original error: " & Ex.Message)
            Finally
                ' Check this again, since we need to make sure we didn't throw an exception on open.
                If (myStream3 IsNot Nothing) Then

                End If
            End Try
        End If
    End Sub

    Private Sub txtFile1_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtFile1.TextChanged
        If (txtFile1.Text <> Nothing) Then
            If (txtFile2.Text <> Nothing) Then
                btnCompare.Enabled = True
            Else
                btnCompare.Enabled = False
            End If
        Else
            btnCompare.Enabled = False
        End If
    End Sub

    Private Sub txtFile2_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtFile2.TextChanged
        If (txtFile1.Text <> Nothing) Then
            If (txtFile2.Text <> Nothing) Then
                btnCompare.Enabled = True
            Else
                btnCompare.Enabled = False
            End If
        Else
            btnCompare.Enabled = False
        End If
    End Sub

    Friend Sub Complete(ByVal [text] As String)
        If Me.prgCompare.InvokeRequired Then
            Dim _delegate As New ContextCallback(AddressOf Complete)
            Me.Invoke(_delegate, New Object() {[text]})
        Else
            Me.prgCompare.Value = 0
            Me.mnuOptions.Enabled = True
            Completed = True
            Me.mnuStop.Enabled = False
            Me.lblEstTime.Text = Nothing
            myFiles.stopWatch.Stop()
            ThisTime = 0.0
            LastTime = 0.0
            lblPercent.Text = Nothing
        End If
    End Sub

    Friend Sub SetMax(ByVal [text] As String)
        If Me.prgCompare.InvokeRequired Then
            Dim _delegate As New ContextCallback(AddressOf SetMax)
            Me.Invoke(_delegate, New Object() {[Text]})
        Else
            Me.prgCompare.Maximum = CInt([text])
        End If
    End Sub

    ' This will be called from the worker thread to set
    ' the work's progress
    Friend Sub UpdateUI(ByVal [text] As String)
        If Me.prgCompare.InvokeRequired Then
            Dim _delegate As New ContextCallback(AddressOf UpdateUI)
            Me.Invoke(_delegate, New Object() {[text]})
        Else
            Dim myText As Integer = CInt([text])
            Me.prgCompare.Value = myText
            If (myText > 0) Then
                lblPercent.Text = Decimal.Round(((myText / Me.prgCompare.Maximum) * 100), 2, MidpointRounding.AwayFromZero) & "%"
            End If
        End If
    End Sub

    Friend Sub UpdateList(ByVal [text] As String)
        If Me.prgCompare.InvokeRequired Then
            Dim _delegate As New ContextCallback(AddressOf UpdateList)
            Me.Invoke(_delegate, New Object() {[text]})
        Else
            Me.lstDifference.Items.Add([text])
        End If
    End Sub

    Private Sub mnuNumerical_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuNumerical.Click
        mnuNumerical.Checked = True
        mnuHex.Checked = False
    End Sub

    Private Sub mnuHex_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuHex.Click
        mnuNumerical.Checked = False
        mnuHex.Checked = True
    End Sub

    Private Sub mnuVHex_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuVHex.Click
        mnuVNumerical.Checked = False
        mnuVHex.Checked = True
    End Sub

    Private Sub mnuVNumerical_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuVNumerical.Click
        mnuVNumerical.Checked = True
        mnuVHex.Checked = False
    End Sub

    Private Sub mnuStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuStop.Click
        myFiles.Stopper = True
    End Sub

    Private Sub mnuShowInfo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuShowInfo.Click
        If (mnuShowInfo.Checked = True) Then
            mnuShowInfo.Checked = False
            myFiles.print = False
        Else
            mnuShowInfo.Checked = True
            myFiles.print = True
        End If
    End Sub
End Class
